/* ------------------------------------------------------------ */
/* Rexx Webshere MQ Browse-Get-Put utility      10.03.2009, und */
/* Using client connection channels to VSE and non VSE QM       */
/* ------------------------------------------------------------ */
/* Requires: RXMQT.dll (Rexx-MQ-Routine-Client)                 */
/*           RxTrans.rex (EBCDIC to ASCII conversion)           */
/* WMQ Support Pac MA95. Version 1.0 (C)                        */
/* Copyright IBM Corporation. 1997, 2008.                       */
/* Call SysDumpVariables "MyVars.Lst"                           */
/* ------------------------------------------------------------ */
parse arg parms

/* ------------------------------------------------------------ */
call PrgInit
call SetWmqServer
call FileInit
call WmqInit
call ProcessQueue
call EndProcedure
exit
/* ------------------------------------------------------------ */

/* ------------------------------------------------------------ */
PrgInit:
/* ------------------------------------------------------------ */
  rcInit = 999 ; rcConn = 999 ; rcOpen = 999 ; rcGet = 999 ; rcPut = 999 ; rcClose = 999 ; rcDisc = 999 ; rcOp = 999
  hLine = "="~copies(75) || ">"
  if parms~length = 0
  then do
    say hLine
    say "Usage: [BROWSE GET] QmgrName QueueName "
    /* say "Usage: [BROWSE GET Move Put] QmgrName QueueName FileName" */
    say "B MQFFM01 TEST.QUEUE"
    say hLine
    exit -2222
  end
  else do
    parms = parms~translate
    parse var parms mqOpt WmqServer QueueName FileName rxTrace
  end
  if rxTrace = 1 then trace ?i
  j = 0
return

/* ------------------------------------------------------------ */
SetWmqServer:
/* ------------------------------------------------------------ */
  /* ---> Non VSE Server -------------------------------------- */
  vseMqs = 0
  msgLen = 104857600
  msgLen = 4194
  select
    when WmqServer = "MQAMS2"   then "SET MQSERVER=MQAMS2T.CH/TCP/ff0p5294apx.de.dresdnerkb.com(1415)"
    when WmqServer = "MQAMS8"   then "SET MQSERVER=MQAMS8.CH/TCP/ff0p5294apx.de.dresdnerkb.com(1414)"
    when WmqServer = "MQAMS01"  then "SET MQSERVER=MQAMS01T.CH/TCP/171.33.2.35(1414)"
    when WmqServer = "MQBRU2"   then "SET MQSERVER=MQBRU2T.CH/TCP/ff0p5295apx.de.dresdnerkb.com(1415)"
    when WmqServer = "MQBRU8"   then "SET MQSERVER=MQBRU8.CH/TCP/ff0p5295apx.de.dresdnerkb.com(1414)"
    when WmqServer = "MQBRU01"  then "SET MQSERVER=MQBRU01T.CH/TCP/171.32.1.28(1414)"
    when WmqServer = "MQLDN2"   then "SET MQSERVER=MQLDN2T.CH/TCP/ff0p5296apx.de.dresdnerkb.com(1415)"
    when WmqServer = "MQLDN8"   then "SET MQSERVER=MQLDN8.CH/TCP/ff0p5296apx.de.dresdnerkb.com(1414)"
    when WmqServer = "MQMAD2"   then "SET MQSERVER=MQMAD2T.CH/TCP/ff0p5297apx.de.dresdnerkb.com(1415)"
    when WmqServer = "MQMAD8"   then "SET MQSERVER=MQMAD8.CH/TCP/ff0p5297apx.de.dresdnerkb.com(1414)"
    when WmqServer = "MQMAD01"  then "SET MQSERVER=MQMAD01T.CH/TCP/171.9.2.91(1414)"
    when WmqServer = "MQMIL2"   then "SET MQSERVER=MQMIL2T.CH/TCP/ff0p5298apx.de.dresdnerkb.com(1415)"
    when WmqServer = "MQMIL8"   then "SET MQSERVER=MQMIL8.CH/TCP/ff0p5298apx.de.dresdnerkb.com(1414)"
    when WmqServer = "MQMIL01"  then "SET MQSERVER=MQMIL01T.CH/TCP/10.148.201.51(1414)"
    when WmqServer = "MQFFM01"  then "SET MQSERVER=MQFFM01T.CH/TCP/ibfftocw22224.de.AD.drkw.net(1414)"
    when WmqServer = "MQPAR2"   then "SET MQSERVER=MQPAR2T.CH/TCP/ff0p5299apx.de.dresdnerkb.com(1415)"
    when WmqServer = "MQPAR8"   then "SET MQSERVER=MQPAR8.CH/TCP/ff0p5299apx.de.dresdnerkb.com(1414)"
    when WmqServer = "MQPAR01"  then "SET MQSERVER=MQPAR01T.CH/TCP/Ibparpsp32x010(1414)"
    when WmqServer = "MQSIN4"   then "SET MQSERVER=MQSIN4.CH/TCP/IBSINPSP32A005(1414)"
    when WmqServer = "MQTOK01"  then "SET MQSERVER=MQTOK01.CH/TCP/IBTKYPSP32A003(1414)"
    when WmqServer = "MQWAN01"  then "SET MQSERVER=MQWAN01T.CH/TCP/171.46.0.29(1414)"
    when WmqServer = "MQWIE2"   then "SET MQSERVER=MQWIE2T.CH/TCP/ff0p5300apx.de.dresdnerkb.com(1415)"
    when WmqServer = "MQWIE8"   then "SET MQSERVER=MQWIE8T.CH/TCP/ff0p5300apx.de.dresdnerkb.com(1414)"
    when WmqServer = "MQWIE01"  then "SET MQSERVER=MQWIE01T.CH/TCP/171.30.1.218(1414)"
    when WmqServer = "MQMIL8USI"
    then do
      "SET MQSERVER=MQMIL8T.CH/TCP/10.196.110.74(1414)"
      WmqServer = "MQMIL8"
    end
    when WmqServer = "MQWIE2USI"
    then do
      "SET MQSERVER=MQWIE2T.CH/TCP/10.196.110.74(1415)"
      WmqServer = "MQWIE2U"
    end
    otherwise vseMqs = 1
  end

  /* ---> VSE Server ------------------------------------------ */
  if vseMqs
  then do
    "SET MQCCSID=850"
    msgLen = 10000
    select
      when WmqServer = "MQANLA1" then "SET MQSERVER=MQANLA1.CH/TCP/anla.vmp.vse.dresdner.net"
      when WmqServer = "MQANLB1" then "SET MQSERVER=MQANLB1.CH/TCP/anlb.vmp.vse.dresdner.net"
      when WmqServer = "MQANLC1" then "SET MQSERVER=MQANLC1.CH/TCP/anlc.vmp.vse.dresdner.net"
      when WmqServer = "MQANLF1" then "SET MQSERVER=MQANLF1.CH/TCP/anlf.vmp.vse.dresdner.net"
      when WmqServer = "MQANLI1" then "SET MQSERVER=MQANLI1.CH/TCP/anli.vmp.vse.dresdner.net"
      when WmqServer = "MQANLJ1" then "SET MQSERVER=MQANLJ1.CH/TCP/anlj.vmp.vse.dresdner.net"
      when WmqServer = "MQANLR1" then "SET MQSERVER=MQANLR1.CH/TCP/anlr.vmp.vse.dresdner.net"
      when WmqServer = "MQANLT1" then "SET MQSERVER=MQANLT1.CH/TCP/anlt.vmp.vse.dresdner.net"
      when WmqServer = "MQXNLA1" then "SET MQSERVER=MQXNLA1.CH/TCP/xnla.vmp.vse.dresdner.net"
      when WmqServer = "MQXNLB1" then "SET MQSERVER=MQXNLB1.CH/TCP/xnlb.vmp.vse.dresdner.net"
      when WmqServer = "MQXNLE1" then "SET MQSERVER=MQXNLE1.CH/TCP/xnle.vmp.vse.dresdner.net"
      when WmqServer = "MQXNLF1" then "SET MQSERVER=MQXNLF1.CH/TCP/xnlf.vmp.vse.dresdner.net"
      when WmqServer = "MQXNLG1" then "SET MQSERVER=MQXNLG1.CH/TCP/xnlg.vmp.vse.dresdner.net"
      when WmqServer = "MQXNLH1" then "SET MQSERVER=MQXNLH1.CH/TCP/xnlh.vmp.vse.dresdner.net"

      when WmqServer = "MQTSTA1" then "SET MQSERVER=MQTSTA1.CH/TCP/tsta.vme.vse.dresdner.net"
      when WmqServer = "MQTSTB1" then "SET MQSERVER=MQTSTB1.CH/TCP/tstb.vme.vse.dresdner.net"
      when WmqServer = "MQTSTC1" then "SET MQSERVER=MQTSTC1.CH/TCP/ts2c.vme.vse.dresdner.net"
      when WmqServer = "MQTSTF1" then "SET MQSERVER=MQTSTF1.CH/TCP/tstf.vme.vse.dresdner.net"
      when WmqServer = "MQTSTI1" then "SET MQSERVER=MQTSTI1.CH/TCP/tsti.vme.vse.dresdner.net"
      when WmqServer = "MQTXTA1" then "SET MQSERVER=MQTXTA1.CH/TCP/txta.vme.vse.dresdner.net"
      when WmqServer = "MQTXTB1" then "SET MQSERVER=MQTXTB1.CH/TCP/txtb.vme.vse.dresdner.net"
      when WmqServer = "MQTXTE1" then "SET MQSERVER=MQTXTE1.CH/TCP/txte.vme.vse.dresdner.net"
      when WmqServer = "MQTXTF1" then "SET MQSERVER=MQTXTF1.CH/TCP/txtf.vme.vse.dresdner.net"
      when WmqServer = "MQTXTG1" then "SET MQSERVER=MQTXTG1.CH/TCP/txtg.vme.vse.dresdner.net"
      when WmqServer = "MQTXTH1" then "SET MQSERVER=MQTXTH1.CH/TCP/txth.vme.vse.dresdner.net"
      when WmqServer = "MQANL21" then "SET MQSERVER=MQANL21.CH/TCP/anl2.vme.vse.dresdner.net"
      when WmqServer = "MQANL41" then "SET MQSERVER=MQANL41.CH/TCP/anl4.vme.vse.dresdner.net"
      when WmqServer = "MQANL51" then "SET MQSERVER=MQANL51.CH/TCP/anl5.vme.vse.dresdner.net"
      when WmqServer = "MQANL91" then "SET MQSERVER=MQANL91.CH/TCP/anl9.vme.vse.dresdner.net"
      when WmqServer = "MQVE271" then "SET MQSERVER=MQVE271.CH/TCP/ve27.vme.vse.dresdner.net"
      otherwise do
        say "---> Server not found:" WmqServer
        exit -8888
      end
    end
  end
return

/* ------------------------------------------------------------ */
FileInit:
/* ------------------------------------------------------------ */
  OutPath = "C:\MQ-Tools\Output\"
  OutFile   = WmqServer || "." || QueueName || ".txt"
  OutStream = .stream~new(OutPath || OutFile)
  rcWrite = OutStream~open('write')
  InpPath = "C:\MQ-Tools\Input\"
  InpFile   = "Input.txt"
  InpStream = .stream~new(InpPath || InpFile)
  rcRead = InpStream~open('read')
  GetQueue  = QueueName
  PutQueue  = ""
  say "---> QueueManager:" WmqServer
  say "---> QueueName   :" QueueName
return

/* ------------------------------------------------------------ */
WmqInit:
/* ------------------------------------------------------------ */
  rcc = rxfuncadd('RXMQINIT','RXMQT','RXMQINIT')
  rcc = RXMQINIT()
  parse var rcc rcInit .
  rcc = RXMQCONN(WmqServer)
  parse var rcc rcConn .
  if rcConn <> 0
  then do
    say "---> Connect     :" rcConn
    exit -9999
  end
Return

/* ------------------------------------------------------------ */
ProcessQueue:
/* ------------------------------------------------------------ */
  if mqOpt = "B" | mqOpt = "BX"
  then do
    rcc = RXMQOPEN(GetQueue, mqoo_input_shared + mqoo_browse, 'h2', 'ood.')
    parse var rcc rcOpen .
    igmo.opt = MQGMO_WAIT + MQGMO_BROWSE_NEXT + MQGMO_ACCEPT_TRUNCATED_MSG /* + MQGMO_CONVERT */
    call GetQueue
  end
  if mqOpt = "G" | mqOpt = "GX"
  then do
    rcc = RXMQOPEN(GetQueue, mqoo_input_shared, 'h2', 'ood.')
    parse var rcc rcOpen .
    igmo.opt = MQGMO_WAIT
    call GetQueue
  end
  if mqOpt = "P"
  then do
    call PutQueue
  end
Return

/* ------------------------------------------------------------ */
GetQueue:
/* ------------------------------------------------------------ */
  say "---> Open Queue  :" rcOpen
  rcGet = 0
  if rcOpen = 0
  then do until rcGet <> 0
    g.0 = msgLen ; g.1 = ''
    rcc = RXMQGET( h2,'g.','igmd.','ogmd.','igmo.','ogmo.')
    parse var rcc rcGet .
    if rcGet = 2079
    then do
      say  "---> Message truncated:" rcGet
      rcGet = 0000
    end
    rcOp = rcGet
    /* if rcGet = */
    if rcGet = 0
    then do
      j = j + 1
/* --- */
      if vseMqs
        /* Translate EBCDIC to ASCII */
      then do
        call 'RxTrans' g.1, e, a
        g.1 = result
      end
/* --- */
      mqHeader = 'PutDate :' ogmd.pd ',' j 'Length :' g.0 ',' 'Data <'
      mqData = g.1
      qdta.j = mqHeader mqData
      /* OutStream~lineout(mqData) */
      OutStream~charout(mqData)
      OutStream~lineout('')
      if mqOpt = "BX" | mqOpt = "GX"
      then do
        call MessageToFile
      end
      /* ---> without dead-letter-header OutStream~lineout(mqData~substr(173)) */
      /* qdta.j = g.1~substr(173)              */
      /* OutStream~charout(g.1~substr(173))    */
      /* OutStream~lineout(qdta.j)             */
      /* OutStream~lineout('')                 */
    end
  end
  /* Call SysDumpVariables "MyVars.Lst" */
  if rcGet = 2033
  then say "---> Get Message : 0 [End_of_Queue]"
  else say "---> Get Failed  :" rcGet
  if rcOpen = 0
  then do
    rcc = RXMQCLOS(h2, mqco_none)
    parse var rcc rcClose .
    say "---> Close Queue :" rcClose
  end
  say "---> Processed   :" j
  qdta.0 = j
Return

/* ------------------------------------------------------------ */
MessageToFile:
/* ------------------------------------------------------------ */
  countFile = 100000 + j
  newFile   = OutPath || countFile || ".txt"
  newStream = .stream~new(newFile)
  rcNewFile = newStream~open('write')
  if rcNewFile = "READY:"
  then do
    newStream~charout(mqData)
    newStream~close
  end
  else do
    say  "---> File Open Failed :" rcNewFile
    say  "---> File Name        :" countFile || ".txt"
  end
Return

/* ------------------------------------------------------------ */
PutQueue:
/* ------------------------------------------------------------ */
  PutQueue = QueueName
  rcc = RXMQOPEN(PutQueue, mqoo_output, 'h2', 'ood.')
  parse var rcc rcOpen .
  ipmd.PER = MQPER_PERSISTENT
  ipmd.form = 'MQSTR'
  ipmo.opt = MQPMO_SYNCPOINT
  do while InpStream~lines > 0
    g.1 = InpStream~linein
    g.0 = g.1~length
    rcc = RXMQPUT( h2,'g.','ipmd.','opmd.','ipmo.','opmo.')
    parse var rcc rcPut .
    rcOp = rcPut
  end
  rcc = RXMQCLOS(h2, mqco_none)
Return

/* ------------------------------------------------------------ */
EndProcedure:
/* ------------------------------------------------------------ */
  OutStream~close
  InpStream~close
  if rcConn = 0
  then do
    rcc = RXMQDISC()
    parse var rcc rcDisc .
    say "---> Disconnect  : Conn("rcConn") Open("rcOpen") Oper("rcOp") Disc("rcDisc")"
  end
  say "---> Hit <ENTER> to return"
  pull .
Return
